<script lang="ts" setup>
import { useUserStore } from "@/stores/user";
import { ref } from "vue";
import { VForm } from "vuetify/components";
const form = ref<VForm | null>(null);
const userStore = useUserStore();
async function save() {
  const { valid } = await form.value!.validate();
  if (valid) {
    await userStore.saveUser();
  }
}
</script>

<template>
  <v-dialog v-model="userStore.dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">User</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="form">
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  label="Username*"
                  required
                  v-model="userStore.editedUser.username"
                  :rules="[
                    (v) => !!v || 'Item is required',
                    (v) => v.length >= 4 || 'Length must more than 4',
                  ]"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Password*"
                  required
                  v-model.number="userStore.editedUser.password"
                  :rules="[
                    (v) => !!v || 'Item is required',
                    (v) => v.length >= 5 || 'Length must more than 5',
                  ]"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="userStore.dialog = false"
        >
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
